<?php
/**
 * InlineObject20
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject20 Class Doc Comment
 *
 * @category Class
 * @description configuration of smtp server settings (for sending mails)
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject20 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_20';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'smtpAddress' => 'string',
        'smtpHost' => 'string',
        'smtpUser' => 'string',
        'smtpPassword' => 'string',
        'smtpAuth' => 'bool',
        'smtpEncryptionType' => 'string',
        'smtpSenderName' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'smtpAddress' => null,
        'smtpHost' => null,
        'smtpUser' => null,
        'smtpPassword' => null,
        'smtpAuth' => null,
        'smtpEncryptionType' => null,
        'smtpSenderName' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'smtpAddress' => 'smtpAddress',
        'smtpHost' => 'smtpHost',
        'smtpUser' => 'smtpUser',
        'smtpPassword' => 'smtpPassword',
        'smtpAuth' => 'smtpAuth',
        'smtpEncryptionType' => 'smtpEncryptionType',
        'smtpSenderName' => 'smtpSenderName'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'smtpAddress' => 'setSmtpAddress',
        'smtpHost' => 'setSmtpHost',
        'smtpUser' => 'setSmtpUser',
        'smtpPassword' => 'setSmtpPassword',
        'smtpAuth' => 'setSmtpAuth',
        'smtpEncryptionType' => 'setSmtpEncryptionType',
        'smtpSenderName' => 'setSmtpSenderName'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'smtpAddress' => 'getSmtpAddress',
        'smtpHost' => 'getSmtpHost',
        'smtpUser' => 'getSmtpUser',
        'smtpPassword' => 'getSmtpPassword',
        'smtpAuth' => 'getSmtpAuth',
        'smtpEncryptionType' => 'getSmtpEncryptionType',
        'smtpSenderName' => 'getSmtpSenderName'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const SMTP_ENCRYPTION_TYPE_NONE = 'NONE';
    public const SMTP_ENCRYPTION_TYPE_SSL = 'SSL';
    public const SMTP_ENCRYPTION_TYPE_TLS = 'TLS';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getSmtpEncryptionTypeAllowableValues()
    {
        return [
            self::SMTP_ENCRYPTION_TYPE_NONE,
            self::SMTP_ENCRYPTION_TYPE_SSL,
            self::SMTP_ENCRYPTION_TYPE_TLS,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['smtpAddress'] = $data['smtpAddress'] ?? null;
        $this->container['smtpHost'] = $data['smtpHost'] ?? null;
        $this->container['smtpUser'] = $data['smtpUser'] ?? null;
        $this->container['smtpPassword'] = $data['smtpPassword'] ?? null;
        $this->container['smtpAuth'] = $data['smtpAuth'] ?? null;
        $this->container['smtpEncryptionType'] = $data['smtpEncryptionType'] ?? null;
        $this->container['smtpSenderName'] = $data['smtpSenderName'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getSmtpEncryptionTypeAllowableValues();
        if (!is_null($this->container['smtpEncryptionType']) && !in_array($this->container['smtpEncryptionType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'smtpEncryptionType', must be one of '%s'",
                $this->container['smtpEncryptionType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets smtpAddress
     *
     * @return string|null
     */
    public function getSmtpAddress()
    {
        return $this->container['smtpAddress'];
    }

    /**
     * Sets smtpAddress
     *
     * @param string|null $smtpAddress e-mail address for sending e-mails
     *
     * @return self
     */
    public function setSmtpAddress($smtpAddress)
    {
        $this->container['smtpAddress'] = $smtpAddress;

        return $this;
    }

    /**
     * Gets smtpHost
     *
     * @return string|null
     */
    public function getSmtpHost()
    {
        return $this->container['smtpHost'];
    }

    /**
     * Sets smtpHost
     *
     * @param string|null $smtpHost host (address) of the smtp server
     *
     * @return self
     */
    public function setSmtpHost($smtpHost)
    {
        $this->container['smtpHost'] = $smtpHost;

        return $this;
    }

    /**
     * Gets smtpUser
     *
     * @return string|null
     */
    public function getSmtpUser()
    {
        return $this->container['smtpUser'];
    }

    /**
     * Sets smtpUser
     *
     * @param string|null $smtpUser username of the smtp server
     *
     * @return self
     */
    public function setSmtpUser($smtpUser)
    {
        $this->container['smtpUser'] = $smtpUser;

        return $this;
    }

    /**
     * Gets smtpPassword
     *
     * @return string|null
     */
    public function getSmtpPassword()
    {
        return $this->container['smtpPassword'];
    }

    /**
     * Sets smtpPassword
     *
     * @param string|null $smtpPassword password of the smtp server
     *
     * @return self
     */
    public function setSmtpPassword($smtpPassword)
    {
        $this->container['smtpPassword'] = $smtpPassword;

        return $this;
    }

    /**
     * Gets smtpAuth
     *
     * @return bool|null
     */
    public function getSmtpAuth()
    {
        return $this->container['smtpAuth'];
    }

    /**
     * Sets smtpAuth
     *
     * @param bool|null $smtpAuth true if the smtp server requires authentication
     *
     * @return self
     */
    public function setSmtpAuth($smtpAuth)
    {
        $this->container['smtpAuth'] = $smtpAuth;

        return $this;
    }

    /**
     * Gets smtpEncryptionType
     *
     * @return string|null
     */
    public function getSmtpEncryptionType()
    {
        return $this->container['smtpEncryptionType'];
    }

    /**
     * Sets smtpEncryptionType
     *
     * @param string|null $smtpEncryptionType enum representing the security setting of the mail server
     *
     * @return self
     */
    public function setSmtpEncryptionType($smtpEncryptionType)
    {
        $allowedValues = $this->getSmtpEncryptionTypeAllowableValues();
        if (!is_null($smtpEncryptionType) && !in_array($smtpEncryptionType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'smtpEncryptionType', must be one of '%s'",
                    $smtpEncryptionType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['smtpEncryptionType'] = $smtpEncryptionType;

        return $this;
    }

    /**
     * Gets smtpSenderName
     *
     * @return string|null
     */
    public function getSmtpSenderName()
    {
        return $this->container['smtpSenderName'];
    }

    /**
     * Sets smtpSenderName
     *
     * @param string|null $smtpSenderName send mails with this displayed name (optional)
     *
     * @return self
     */
    public function setSmtpSenderName($smtpSenderName)
    {
        $this->container['smtpSenderName'] = $smtpSenderName;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


